/* <INSERT COPYRIGHT & LICENSE TEXT HERE> */

#ifndef DAC80502_H_
#define DAC80502_H_

#include <stdint.h>


//**********************************************************************************
//
// Function prototypes
//
//**********************************************************************************



//**********************************************************************************
//
// Device commands
//
//**********************************************************************************



//**********************************************************************************
//
// Register definitions
//
//**********************************************************************************


/* Register 0x00 (NOOP) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                               NO OPERATION[15:0]                                                                                                                                              |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* NOOP register address */
    #define NOOP_ADDRESS													((uint8_t) 0x00)

    /* NOOP default (reset) value */
    #define NOOP_DEFAULT													((uint16_t) 0x0000)

    /* NOOP register field masks */
    #define NOOP_NO OPERATION_MASK											((uint16_t) 0xFFFF)



/* Register 0x01 (DEVID) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         0        |                     RESOLUTION[2:0]                    |         0        |         1        |         1        |         0        |         0        |         0        |         1        |         1        |         1        |         1        |         0        |         1        |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DEVID register address */
    #define DEVID_ADDRESS													((uint8_t) 0x01)

    /* DEVID default (reset) value */
    #define DEVID_DEFAULT													((uint16_t) 0x0215)

    /* DEVID register field masks */
    #define DEVID_RESOLUTION_MASK											((uint16_t) 0x7000)



/* Register 0x02 (SYNC) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         0        |         0        |         0        |         0        |         0        |         0        | DAC-B-BRDCAST-EN | DAC-A-BRDCAST-EN |         0        |         0        |         0        |         0        |         0        |         0        |   DAC-B-SYNC-EN  |   DAC-A-SYNC-EN  |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* SYNC register address */
    #define SYNC_ADDRESS													((uint8_t) 0x02)

    /* SYNC default (reset) value */
    #define SYNC_DEFAULT													((uint16_t) 0x0300)

    /* SYNC register field masks */
    #define SYNC_DAC-B-BRDCAST-EN_MASK										((uint16_t) 0x0200)
    #define SYNC_DAC-A-BRDCAST-EN_MASK										((uint16_t) 0x0100)
    #define SYNC_DAC-B-SYNC-EN_MASK											((uint16_t) 0x0002)
    #define SYNC_DAC-A-SYNC-EN_MASK											((uint16_t) 0x0001)



/* Register 0x03 (CONFIG) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         0        |         0        |         0        |         0        |         0        |         0        |         0        |     REF-PWDWN    |         0        |         0        |         0        |         0        |         0        |         0        |    DAC-B-PWDWN   |    DAC-A-PWDWN   |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* CONFIG register address */
    #define CONFIG_ADDRESS													((uint8_t) 0x03)

    /* CONFIG default (reset) value */
    #define CONFIG_DEFAULT													((uint16_t) 0x0000)

    /* CONFIG register field masks */
    #define CONFIG_REF-PWDWN_MASK											((uint16_t) 0x0100)
    #define CONFIG_DAC-B-PWDWN_MASK											((uint16_t) 0x0002)
    #define CONFIG_DAC-A-PWDWN_MASK											((uint16_t) 0x0001)



/* Register 0x04 (GAIN) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         0        |         0        |         0        |         0        |         0        |         0        |         0        |      REF-DIV     |         0        |         0        |         0        |         0        |         0        |         0        |   BUFF-B -GAIN   |   BUFF-A -GAIN   |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* GAIN register address */
    #define GAIN_ADDRESS													((uint8_t) 0x04)

    /* GAIN default (reset) value */
    #define GAIN_DEFAULT													((uint16_t) 0x0003)

    /* GAIN register field masks */
    #define GAIN_REF-DIV_MASK												((uint16_t) 0x0100)
    #define GAIN_BUFF-B -GAIN_MASK											((uint16_t) 0x0002)
    #define GAIN_BUFF-A -GAIN_MASK											((uint16_t) 0x0001)



/* Register 0x05 (TRIGGER) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |       LDAC       |                            SOFT-RESET[3:0][3:0]                           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* TRIGGER register address */
    #define TRIGGER_ADDRESS													((uint8_t) 0x05)

    /* TRIGGER default (reset) value */
    #define TRIGGER_DEFAULT													((uint16_t) 0x0000)

    /* TRIGGER register field masks */
    #define TRIGGER_LDAC_MASK												((uint16_t) 0x0010)
    #define TRIGGER_SOFT-RESET[3:0]_MASK									((uint16_t) 0x000F)



/* Register 0x06 (BRDCAST) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                               BRDCAST-DATA[15:0]                                                                                                                                              |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* BRDCAST register address */
    #define BRDCAST_ADDRESS													((uint8_t) 0x06)

    /* BRDCAST default (reset) value */
    #define BRDCAST_DEFAULT													((uint16_t) 0x0000)

    /* BRDCAST register field masks */
    #define BRDCAST_BRDCAST-DATA_MASK										((uint16_t) 0xFFFF)



/* Register 0x07 (STATUS) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                  |                  |                  |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |         0        |     REF-ALARM    |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* STATUS register address */
    #define STATUS_ADDRESS													((uint8_t) 0x07)

    /* STATUS default (reset) value */
    #define STATUS_DEFAULT													((uint16_t) 0x0000)

    /* STATUS register field masks */
    #define STATUS_REF-ALARM_MASK											((uint16_t) 0x0001)



/* Register 0x08 (DAC-A-DATA) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                           DAC-A-DATA-REGISTER[15:0]                                                                                                                                           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-A-DATA register address */
    #define DAC-A-DATA_ADDRESS												((uint8_t) 0x08)

    /* DAC-A-DATA default (reset) value */
    #define DAC-A-DATA_DEFAULT												((uint16_t) 0x0000)

    /* DAC-A-DATA register field masks */
    #define DAC-A-DATA_DAC-A-DATA-REGISTER_MASK								((uint16_t) 0xFFFF)



/* Register 0x09 (DAC-B-DATA) definition
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |      Bit 15      |      Bit 14      |      Bit 13      |      Bit 12      |      Bit 11      |      Bit 10      |       Bit 9      |       Bit 8      |       Bit 7      |       Bit 6      |       Bit 5      |       Bit 4      |       Bit 3      |       Bit 2      |       Bit 1      |       Bit 0      |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 * |                                                                                                                                           DAC-B-DATA-REGISTER[15:0]                                                                                                                                           |
 * |---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
 */

    /* DAC-B-DATA register address */
    #define DAC-B-DATA_ADDRESS												((uint8_t) 0x09)

    /* DAC-B-DATA default (reset) value */
    #define DAC-B-DATA_DEFAULT												((uint16_t) 0x0000)

    /* DAC-B-DATA register field masks */
    #define DAC-B-DATA_DAC-B-DATA-REGISTER_MASK								((uint16_t) 0xFFFF)



#endif /* DAC80502_H_ */
